C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
C
C--PROGRAM NAME--
C                ALLPROPS.for
C
C--DESCRIPTION--
C                Driver program for fluid property package.
C
C--CONTENTS-----
C  Main program: ALLPROPS
C
C  Subroutines:  BANNER
C                FLUIDS(IFLUID, CHOICE)
C                FACT
C                OUTX(OPT)
C                OUTPUTX(CON)
C                UNITS(ISET)
C                SAVECO(RUNX)
C                PROPS(P, D, T, TAG, PFLAG, QFLAG, SATFLG)
C                STATUS
C                INPUT2(PROP1, PROP2, PROPINC, ERRORX, OFFSET, FACTOR)
C                SPCALC
C                TABLES
C
C  Functions:    FORMT(PRP)
C
C=======================================================================
C
      PROGRAM ALLPROPS
C
C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
C
C  PURPOSE:
C
C     Interactive driver program for cats thermodynamic property
C     formulations.
C
C-----------------------------------------------------------------------
      INCLUDE 'commons.for'
      INCLUDE 'comdrv.for'

C--Local Variables----------------------
      CHARACTER OPT*1
      INTEGER IFLUID, I

C-----------------------------------------------------------------------
      PRNTFLG = .TRUE.
      IDGPRP = .FALSE.
      ERRMSG = .TRUE.
      CALL UNDER0(.TRUE.)
      CALL BANNER
      OPTSET = '1'
      OUTOPT = 'nul'
      IDGTITLE = '(17X,''Ideal Gas Thermodynamic Properties of '',A25)'
      TITLE = '(22X,''Thermodynamic Properties of '',A25)'
      TITLE1 = '(1X,78(''=''),/,2(A79,/),1X,78(''=''))'
      TITLEQ = .TRUE.
      IOUT = 1
      IFLUID = 1
      VAR(1) = 1
      VAR(2) = 1
      VAR(3) = 1
      VAR(6) = 1
      VAR(7) = 1
      VAR(8) = 1
      VAR(10) = 1
      DO 15 I = 1, NS
 15   STATES(I) = ' '
      NME(IFLUID) = ' '
      TNAMEQ(IFLUID) = ' '
      OPEN (IOUT, FILE = OUTOPT)
      CALL SAVECO(0, IFLUID)
      CALL FLUIDS(IFLUID)

C--Enter the Main Menu--------------------------------------------------
 100  CALL SYSTEM("CLS")
      IF (PRNTFLG) WRITE (*,1000)
 1000 FORMAT ('  MAIN MENU (Select an option):',//,
     &'  (1)  Calc.    (Calculate fluid properties)',/,
     &'  (2)  Options  (Select fluid, output device, or units)',/,
     &'  (3)  Status   (View program status)',/,
     &'  (4)  Save configuration to a file  ',/,
     &'  (5)  Exit     (Exit to Operating System)',//)
      READ (*,'(A1)') OPT

C--Calc. Menu:  Calculate thermodynamic properties----------------------
      IF (OPT.EQ.'1' .OR. OPT.EQ.'C' .OR. OPT.EQ.'c') THEN
 110    CALL SYSTEM("CLS")
        IF (PRNTFLG) WRITE (*,1010)
 1010   FORMAT ('  CALCULATE MENU (Select an option):',//,
     &  '  (1)  Point   (Calculate properties at a single point)',/,
     &  '  (2)  Tables  (Generate a property table)',/,
     &  '  (3)  Status  (View program status)',/,
     &  '  (0)  Quit    (Return to the main menu)',//)
        READ (*,'(A1)') OPT
        IF (OPT.EQ.'1' .OR. OPT.EQ.'P' .OR. OPT.EQ.'p') THEN
          CALL OUTX(3)
          CALL SPCALC
          GOTO 100
        ELSEIF (OPT.EQ.'2' .OR. OPT.EQ.'T' .OR. OPT.EQ.'t') THEN
          CALL OUTX(3)
          CALL TABLES
          GOTO 100
        ELSEIF (OPT.EQ.'3' .OR. OPT.EQ.'S' .OR. OPT.EQ.'s') THEN
          CALL STATUS
          GOTO 110
        ELSEIF (OPT.EQ.'0' .OR. OPT.EQ.'Q' .OR. OPT.EQ.'q') THEN
          GOTO 100
        ELSE
          GOTO 110
        ENDIF

C--Options Menu: Select an Output Device or Units-----------------------
      ELSEIF (OPT.EQ.'2' .OR. OPT.EQ.'O' .OR. OPT.EQ.'o') THEN
 120    CALL SYSTEM("CLS")
        IF (PRNTFLG) WRITE (*,1020)
 1020   FORMAT ('  OPTIONS MENU (Select an option):',//,
     &  '  (1)  Fluid   (Select a working fluid)',/,
     &  '  (2)  Output  (Select an output device)',/,
     &  '  (3)  Units   (Select a system of units)',/,
     &  '  (4)  Display (Select which variables to display)',/,
     &  '  (5)  Idgas   (Select ideal or real gas properties)',/,
     &  '  (6)  Status  (View program status)',/,
     &  '  (7)  Titles  (Select whether titles are printed)',/,
     &  '  (0)  Quit    (Return to the main menu)',//)
        READ (*,'(A1)') OPT
        IF (OPT.EQ.'1' .OR. OPT.EQ.'F' .OR. OPT.EQ.'f') THEN
          NME(IFLUID) = ' '
          CALL FLUIDS(IFLUID)
          GOTO 100
        ELSEIF (OPT.EQ.'2' .OR. OPT.EQ.'O' .OR. OPT.EQ.'o') THEN
          CALL OUTPUTX(0)
          GOTO 100
        ELSEIF (OPT.EQ.'3' .OR. OPT.EQ.'U' .OR. OPT.EQ.'u') THEN
          CALL UNITS(1)
          GOTO 100
        ELSEIF (OPT.EQ.'4' .OR. OPT.EQ.'D' .OR. OPT.EQ.'d') THEN
          CALL OUTX(0)
          GOTO 100
        ELSEIF (OPT.EQ.'5' .OR. OPT.EQ.'I' .OR. OPT.EQ.'i') THEN
          CALL SYSTEM("CLS")
          IF (PRNTFLG) WRITE (*,1030)
 1030     FORMAT ('  Select an Option:',//,
     &            '  (1)  Calculate ideal gas properties',/,
     &            '  (2)  Calculate real fluid properites',/,
     &            '  (0)  Return to main menu',//)
          READ (*,'(A1)') OPT
          IF (OPT.EQ.'2') IDGPRP = .FALSE.
          IF (OPT.EQ.'1') IDGPRP = .TRUE.
          GOTO 100
        ELSEIF (OPT.EQ.'6' .OR. OPT.EQ.'S' .OR. OPT.EQ.'s') THEN
          CALL STATUS
          GOTO 120
        ELSEIF (OPT.EQ.'7' .OR. OPT.EQ.'T' .OR. OPT.EQ.'t') THEN
          CALL SYSTEM("CLS")
          IF (PRNTFLG) WRITE (*,1040)
 1040     FORMAT ('  Select an Option:',//,
     &            '  (1)  Write titles to output file',/,
     &            '  (2)  Do NOT write titles to output file',/,
     &            '  (0)  Return to main menu',//)
          READ (*,'(A1)') OPT
          IF (OPT.EQ.'2') TITLEQ = .FALSE.
          IF (OPT.EQ.'1') TITLEQ = .TRUE.
          GOTO 100
        ELSEIF (OPT.EQ.'0' .OR. OPT.EQ.'Q' .OR. OPT.EQ.'q') THEN
          GOTO 100
        ELSE
          GOTO 120
        ENDIF

C--Status: view the status screen---------------------------------------
      ELSEIF (OPT.EQ.'3' .OR. OPT.EQ.'S' .OR. OPT.EQ.'s') THEN
        CALL STATUS
        GOTO 100

C--Save Configuration---------------------------------------------------
      ELSEIF (OPT.EQ.'4' .OR. OPT.EQ.'c' .OR. OPT.EQ.'C') THEN
        CALL SAVECO(1, IFLUID)
        GOTO 100

C--Exit to Dos----------------------------------------------------------
      ELSEIF (OPT.EQ.'5' .OR. OPT.EQ.'E' .OR. OPT.EQ.'e') THEN
        STOP
      ELSE
        GOTO 100
      ENDIF
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE BANNER
C
C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
      INCLUDE 'commons.for'

C--Local Variables----------------------
      CHARACTER*3 CCHOICE

C-----------------------------------------------------------------------
      CALL SYSTEM("CLS")
      IF (PRNTFLG) WRITE (*,1000)
      IF (PRNTFLG) WRITE (*,*) 'Press <Enter> To continue ... '
      READ (*,'(A3)')CCHOICE
      IF (CCHOICE.EQ.' ') THEN
        INTERQ = .TRUE.
      ELSEIF (CCHOICE.EQ.'NUL' .OR. CCHOICE.EQ.'nul') THEN
        PRNTFLG = .FALSE.
      ELSE
        INTERQ = .FALSE.
      ENDIF
C
 1000 FORMAT(
     &/10X,'ͻ',
     &/10X,'                                                        ',
     &/10X,'                                ',
     &/10X,'                   ALLPROPS                 ',
     &/10X,'                                ',
     &/10X,'                                                        ',
     &/10X,'        Thermodynamic Properties of Fluids      ',
     &/10X,'                                                        ',
     &/10X,'                     (Version 4.02)                     ',
     &/10X,'                   (C) Copyright 1993                   ',
     &/10X,'                                                        ',
     &/10X,'                     Distributed by:                    ',
     &/10X,'                                                        ',
     &/10X,'      The Center for Applied Thermodynamic Studies      ',
     &/10X,'                 College of Engineering                 ',
     &/10X,'           University of Idaho, Moscow, Idaho           ',
     &/10X,'                                                        ',
     &/10X,' Disclaimer:  User assumes all risk and responsibility. ',
     &/10X,'                                                        ',
     &/10X,'ͼ',
     &//)
C1000 FORMAT(24(/),
C    &/10X,'**********************************************************',
C    &/10X,'*                                                        *',
C    &/10X,'*                      A L L P R O P S                   *',
C    &/10X,'*                                                        *',
C    &/10X,'*       **** Thermodynamic Properties of Fluids ****     *',
C    &/10X,'*                                                        *',
C    &/10X,'*                     (Version 4.02)                     *',
C    &/10X,'*                   (C) Copyright 1993                   *',
C    &/10X,'*                                                        *',
C    &/10X,'*                     Distributed by:                    *',
C    &/10X,'*                                                        *',
C    &/10X,'*      The Center for Applied Thermodynamic Studies      *',
C    &/10X,'*                 College of Engineering                 *',
C    &/10X,'*           University of Idaho, Moscow, Idaho           *',
C    &/10X,'*                                                        *',
C    &/10X,'* Disclaimer:  User assumes all risk and responsibility. *',
C    &/10X,'*                                                        *',
C    &/10X,'**********************************************************',
C    &//)
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE FLUIDS(IFLUID)
C
C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
C
C  PURPOSE:
C
C     Routine to select a working fluid.   This routine calls the
C     reference routine for the selected fluid.
C
C-----------------------------------------------------------------------
      INCLUDE 'commons.for'

C--Arguments----------------------------
      INTEGER IFLUID

C--Local Variables----------------------
      CHARACTER FXNAME*80, FXNAMES(30)*8, LINE*80
      INTEGER OPT

      DATA FXNAMES/
     &'Air     ','Nitrogen','Argon   ','Oxygen  ','Neon    ',
     &'Hydrogen','Parahyd ','Helium  ',' ',
     &'Methane ','Ethane  ','Propane ','nButane ','iButane ',
     &'Ethylene','Propylne','Cyclohex',' ',' ',
     &'Water   ','Co2     ','Ammonia ',' ',' ',' ',' ',' ',' ',' ',' '/
C-----------------------------------------------------------------------
      IF (NME(IFLUID).EQ.' ') THEN
 200    CALL SYSTEM("CLS")
        IF (PRNTFLG) WRITE (*,1000)
        READ (*,*) LINE
        FXNAME = LINE
        READ (LINE,*,ERR=210) OPT
        IF (OPT.EQ.0) RETURN
        IF (OPT.LT.1 .OR. OPT.GT.30) GOTO 200
        IF (FXNAMES(OPT).EQ.' ') GOTO 200
        FXNAME = FXNAMES(OPT)
      ELSE
        FXNAME = NME(IFLUID)
      ENDIF

 210  CALL READREF(FXNAME, IFLUID)
      CALL UNITS(0)
C     IF (PRNTFLG) WRITE (*,1010) TNAMEQ(IFLUID)
C     IF (INTERQ) CALL PAUSE2
C-----------------------------------------------------------------------
 1000 FORMAT ('  FLUIDS MENU (Enter a fluid number or name):',//,
     &'  --Cryogens--                     --Polar Fluids--     ',/,
     &'  (1)  Air                         (20)  Water          ',/,
     &'  (2)  Nitrogen                    (21)  Carbon Dioxide ',/,
     &'  (3)  Argon                       (22)  Ammonia        ',/,
     &'  (4)  Oxygen                                           ',/,
     &'  (5)  Neon                       -----Refrigerants---- ',/,
     &'  (6)  Hydrogen                   R11     R113    RC318 ',/,
     &'  (7)  Parahydrogen               R12     R114    R500  ',/,
     &'  (8)  Helium                     R13     R115    R503  ',/,
     &'                                  R13B1   R123          ',/,
     &'  --Hydrocarbons--                R14     R125          ',/,
     &' (10)  Methane                    R21     R134a         ',/,
     &' (11)  Ethane                     R22     R141b         ',/,
     &' (12)  Propane                    R23     R142b         ',/,
     &' (13)  n-Butane                   R32     R152a         ',/,
     &' (14)  i-Butane                                         ',/,
     &' (15)  Ethylene                                         ',/,
     &' (16)  Propylene                                        ',/,
     &' (17)  Cyclohexane                                      ',/,
     &/'  ---> ')
C1010 FORMAT ('  The current working fluid is: ',A25,//)
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE OUTPUTX(CON)
C
C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
C
C  PURPOSE:
C
C     Select an output device.
C
C-----------------------------------------------------------------------
      INCLUDE 'commons.for'
      INCLUDE 'comdrv.for'

C--Arguments----------------------------
      INTEGER CON

C--Local Variables----------------------
      CHARACTER OPT*1

C-----------------------------------------------------------------------
 500  IF (CON.EQ.0) THEN
        CALL SYSTEM("CLS")
        IF (PRNTFLG) WRITE (*,1000)
        READ (*,'(A1)') OPT
      ENDIF

C--Choose Display for Output--------------------------------------------
      IF (OPT.EQ.'1' .OR. OPT.EQ.'D' .OR. OPT.EQ.'d' .OR.CON.EQ.1) THEN
        OUTOPT = 'nul'
        OPEN (IOUT, FILE = OUTOPT)
        PRNTFLG = .TRUE.

C--Choose File Only for Output--------------------------------------------
      ELSEIF (OPT.EQ.'4') THEN
        PRNTFLG = .FALSE.

C--Choose a File and Display for Output---------------------------------
      ELSEIF (OPT.EQ.'2' .OR. OPT.EQ.'F' .OR. OPT.EQ.'f' .OR.
     &        CON.EQ.2) THEN
        IF (CON.NE. 2) THEN
          WRITE (*,'('' Enter the filespec for your output file.'',//)')
          READ (*,'(A80)') OUTOPT
          IF (OUTOPT.EQ.' ')OUTOPT = 'nul'
        ENDIF
        OPEN (IOUT, FILE = OUTOPT, STATUS = 'UNKNOWN')
        PRNTFLG = .TRUE.

C--Choose the Printer and Display for Output----------------------------
      ELSEIF (OPT.EQ.'3' .OR. OPT.EQ.'P' .OR. OPT.EQ.'p' .OR.
     &       CON.EQ.3) THEN
        OUTOPT = 'prn'
        OPEN (IOUT, FILE = OUTOPT)
        PRNTFLG = .TRUE.

C--Return to the Main Menu----------------------------------------------
      ELSEIF (OPT.EQ.'0' .OR. OPT.EQ.'Q' .OR. OPT.EQ.'q') THEN
      ELSE
        GOTO 500
      ENDIF

 1000 FORMAT ('  OUTPUT MENU (Select an output option):',//,
     &'  (1)  Display   (Output to the display only)',/,
     &'  (2)  File      (Output to the display and a file)',/,
     &'  (3)  Printer   (Output to the display and the printer)',/,
     &'  (4)  No Screen (Do not send output to screen)',/,
     &'  (0)  Quit      (Return to the main menu)',//)
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE SAVECO(RUNX, IFLUID)
C
C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
C
C  PURPOSE:
C
C     For saving options into a configuration file and reading them
C     from the configuration file.  When runx = 0, read from saved
C     conf.sav file, if it exists.  When runx = 1, write to conf.sav.
C
C-----------------------------------------------------------------------
      INCLUDE 'commons.for'
      INCLUDE 'comdrv.for'

C--Local Variables----------------------
      INTEGER RUNX, CON, CONF, IFLUID
      CHARACTER*80 RECORD, CFNAME

C--If runx is equal to zero try to read the configuration file.----------
      CONF = 91
      IF (RUNX.EQ.0) THEN
        CALL SYSTEM("CLS")
        IF (PRNTFLG) WRITE (*,'(18(/),5X,A32)')'Press ENTER to continue'
        IF (PRNTFLG) WRITE (*,'(/,22X,A6,/)')'- OR -'
        IF (PRNTFLG)
     &   WRITE (*,'(5X,A42)')'Enter Configuration Filename <conf.sav>: '
        READ (*,'(A80)') CFNAME
        IF (CFNAME.EQ.' ') CFNAME = 'conf.sav'
        OPEN (CONF, FILE = CFNAME, STATUS = 'UNKNOWN', ERR=9000)
        READ (CONF,'(A80)',END=9020) RECORD
        CALL NEXTREC(CONF, RECORD)
        READ (RECORD,'(A80)') NME(IFLUID)
        CALL NEXTREC(CONF, RECORD)
        READ (RECORD,'(A80)') OUTOPT
        IF (OUTOPT.EQ.'nul') THEN
          CON = 1
        ELSEIF (OUTOPT.EQ.'prn') THEN
          CON = 3
        ELSE
          CON = 2
        ENDIF
        CALL OUTPUTX(CON)
        CALL NEXTREC(CONF, RECORD)
        READ(RECORD,*) VAR(1),VAR(2),VAR(3),VAR(4),VAR(5),VAR(6),
     &                 VAR(7),VAR(8),VAR(9),VAR(10),VAR(11),VAR(12),
     &                 VAR(13),VAR(14),VAR(15),VAR(16)
        CALL NEXTREC(CONF, RECORD)
        READ(RECORD,*) VAR(17),VAR(18),VAR(19),VAR(20),VAR(21),VAR(22)
        CALL NEXTREC(CONF, RECORD)
        READ(RECORD,*) VAR(23),VAR(24),VAR(25),VAR(26),VAR(27),VAR(28),
     &         VAR(29),VAR(30)
        CALL NEXTREC(CONF, RECORD)
        READ(RECORD,'(A1)') OPTSET
        IF (OPTSET.EQ.'5') THEN
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHP
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHT
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHD
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHB
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHC
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHV
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHH
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHS
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHW
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHVIS
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHK
          CALL NEXTREC(CONF, RECORD)
          READ (RECORD,'(A10)') ALPHST
        ENDIF
        CLOSE(CONF)

C--If runx is equal to one, write a configuration file.------------------
      ELSE
        CALL SYSTEM("CLS")
        WRITE (*,'(20(/),A40)')' Configuration Filename <conf.sav> : '
        READ (*,'(A80)') CFNAME
        IF (CFNAME.EQ.' ') CFNAME = 'conf.sav'
        OPEN(CONF,FILE = CFNAME, STATUS = 'UNKNOWN', ERR=9000)
        WRITE (CONF,*) '#    File Name'
        WRITE (CONF,'(A80)') NME(IFLUID)
        WRITE (CONF,*) '#    Output file (NUL-screen, PRN-printer)'
        WRITE (CONF,'(A80)') OUTOPT
        WRITE(CONF,*) '#    Displayed variables (1 indicates displayed)'
        WRITE (CONF,1000) VAR
        WRITE (CONF,*) '#      Units selection (1-5, 5 is custom)'
        WRITE (CONF,'(A1)') OPTSET
        IF (OPTSET.EQ.'5') THEN
          WRITE (CONF,*) '#    Custom unit selection'
          WRITE (CONF,1010) ALPHP,ALPHT,ALPHD,ALPHB,ALPHC,ALPHV,
     &                     ALPHH,ALPHS,ALPHW,ALPHVIS,ALPHK,ALPHST
        ENDIF
        CLOSE(CONF)
      ENDIF
      RETURN
 9000 WRITE (*,*) ' *** DISK ERROR OCCURED WHILE OPENING FILE ***'
      CALL PAUSE2
      RETURN
 9020 IF (.NOT.(CFNAME.EQ.'nul' .OR. CFNAME.EQ.'NUL'))
     &     CLOSE(CONF, STATUS='DELETE')
 1000   FORMAT (
     & '#    P  T  D  V  U  H  S  Cv Cp W  Z  A  G  B  C  F',/3X,16I3/
     & '#    dP/dT dP/dD d2P/dD2  VIS   THCND    ST',/,6I7/,
     & '#    JT    k     kT   Beta BulkModS Bs  Kappa  BulkModT',/,8I6)
 1010 FORMAT (
     &  A10,T40,'Pressure units',/,
     &  A10,T40,'Temperature units',/,
     &  A10,T40,'Density units',/,
     &  A10,T40,'2rd Virial units',/,
     &  A10,T40,'3rd Virial units',/,
     &  A10,T40,'Specific volume units',/,
     &  A10,T40,'Enthalpy units',/,
     &  A10,T40,'Heat Capacity and Entropy units',/,
     &  A10,T40,'Speed units',/,
     &  A10,T40,'Viscosity units',/,
     &  A10,T40,'Thermal Conductivity units',/,
     &  A10,T40,'Surface Tension units')
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE SPCALC
C
C-----------------------------------------------------------------------
C (C) Copyright 1993  |  Center for Applied Thermodynamic Studies
C                     |  University of Idaho, Moscow, Idaho
C-----------------------------------------------------------------------
C
C  PURPOSE:
C
C    Calculates the thermodymamic properties of the working fluid
C    for many different pairs of input properties.  Single phase
C    states are specified by two input properites.  Coexistence
C    states are specified by either temperature or pressure.
C
C-----------------------------------------------------------------------
      INCLUDE 'commons.for'
      INCLUDE 'comdrv.for'
      INTEGER QUALITYFLAG
      REAL*8 DSL, DSV, Q
      COMMON /QUALITY/ DSL, DSV, Q, QUALITYFLAG

C--Functions Called---------------------
      REAL*8 DOFPT, DOFST, TOFDP, TOFDH, TOFDS

C--Local Variables----------------------
      LOGICAL ERRORX, FLAG
      CHARACTER*10 TAGB, TAGL, TAGV
      CHARACTER*4 TYP
      INTEGER I
      REAL*8 D, H, P, PSL, PSV, S, T, TSL, TSV, PSAT, TSAT

C-----------------------------------------------------------------------
C.....Caution:  The 'Liquid' tag is also used in PROPS to determine if
C  ...the surface tension should be printed.
      TAGB = ' '
      TAGL = ' Liquid'
      TAGV = ' Vapor'
      IF (TITLEQ) THEN
        IF (IDGPRP) THEN
          WRITE (IOUT, IDGTITLE) TNAMEQ(NDX)
          WRITE (IOUT, TITLE2) STRING1, STRING2
        ELSE
          WRITE (IOUT, TITLE) TNAMEQ(NDX)
          WRITE (IOUT, TITLE2) STRING1, STRING2
        ENDIF
      ENDIF

C--Write the Heading, States, and the Single Point Menu to the Screen---
 600  CALL SYSTEM("CLS")
      IF (IDGPRP) THEN
        IF (PRNTFLG) WRITE (*,IDGTITLE) TNAMEQ(NDX)
      ELSE
        IF (PRNTFLG) WRITE (*,TITLE) TNAMEQ(NDX)
      ENDIF
      IF (PRNTFLG) WRITE (*,TITLE1) STRING1, STRING2

      FLAG = .FALSE.
      DO 10 I = 1, NS
        IF (STATES(I).NE.' ') FLAG = .TRUE.
        IF (FLAG .AND. PRNTFLG) WRITE (*,'(A80)') STATES(I)
 10   CONTINUE
      IF (IDGPRP) THEN
        IF (PRNTFLG) WRITE (*,1010)
      ELSE
        IF (PRNTFLG) WRITE (*,1000)
      ENDIF
      READ (*,'(A4)') TYP

C--Clear Slate----------------------------------------------------------
      IF (TYP.EQ.'C   ' .OR. TYP.EQ.'c   ') THEN
        DO 20 I = 1, NS
 20     STATES(I) = ' '
        GOTO 600

C--Calculate Properties for P,T Inputs----------------------------------
      ELSEIF (TYP.EQ.'1   '.OR.TYP.EQ.'PT  '.OR.TYP.EQ.'pt  ') THEN
        CALL INPUT1(P, 1, ERRORX)
        IF (ERRORX) GOTO 600
        CALL INPUT1(T, 2, ERRORX)
        IF (ERRORX) GOTO 600

        IF (T.LT.TC(NDX) .AND. .NOT.IDGPRP .AND. MXWFLG(NDX).LE.0) THEN
          CALL SATT(T, 0, DSL, DSV, PSL, PSV)
          IF (P.LT.PSL .AND. P.GT.PSV) THEN
            CALL PROPS(PSL, DSL, T, TAGL, 0, 0, 1)
            CALL PROPS(PSV, DSV, T, TAGV, 0, 0, 1)
            GOTO 600
          ENDIF
        ENDIF
        ERRMSG = .FALSE.
        D = DOFPT(P, T, 0)
        ERRMSG = .TRUE.
        CALL CKLMTS(P, D, T)
        IF (D.NE.0) THEN
          CALL PROPS(P, D, T, TAGB, 0, 0, 0)
        ELSE
          WRITE (*,*) ' *** INPUTS ARE OUT OF BOUNDS ***'
          CALL PAUSE2
        ENDIF

C--Calculate Properties for P,D Inputs----------------------------------
      ELSEIF (TYP.EQ.'2   '.OR.TYP.EQ.'PD  '.OR.TYP.EQ.'pd  ') THEN
        CALL INPUT1(P, 1, ERRORX)
        IF (ERRORX) GOTO 600
        CALL INPUT1(D, 3, ERRORX)
        IF (ERRORX) GOTO 600
        ERRMSG = .FALSE.
        T = TOFDP(D, P)
        ERRMSG = .TRUE.
        IF (T.NE.0) THEN
          CALL CKLMTS(P, D, T)
          IF (D.NE.0) THEN
            CALL PROPS(P, D, T, TAGB, 0, 0, 0)
            GOTO 600
          ENDIF
        ELSEIF(P.LT.PC(NDX) .AND. P.GT.PSATL(NDX) .AND. .NOT.IDGPRP)THEN
          CALL SATP(P, 0, DSL, DSV, TSL, TSV)
          IF (D.LE.DSL .AND. D.GE.DSV) THEN
            Q = (1.D0/D - 1.D0/DSL)/(1.D0/DSV - 1.D0/DSL)
            CALL PROPS(P, DSL, TSL, TAGL, 0, 0, 1)
            IF (TSL.EQ.TSV) CALL PROPS(P, D, TSV, TAGB, 0, 1, 1)
            CALL PROPS(P, DSV, TSV, TAGV, 0, 0, 1)
            GOTO 600
          ENDIF
        ENDIF
        WRITE (*,*) ' *** DENSITY OUT OF BOUNDS ***'
        CALL PAUSE2

C--Calculate Properties for P,H Inputs----------------------------------
      ELSEIF (TYP.EQ.'3   '.OR.TYP.EQ.'PH  '.OR.TYP.EQ.'ph  ') THEN
        CALL INPUT1(P, 1, ERRORX)
        IF (ERRORX) GOTO 600
        IF (PRNTFLG) WRITE (*,1020) ALPHH
        READ (*,*,ERR=600) H
        H = H*HFACT
        ERRMSG = .FALSE.
        CALL DTOFHP(H, P, D, T)
        ERRMSG = .TRUE.
        IF (D.NE.0) THEN
          CALL CKLMTS(P, D, T)
          IF (D.NE.0) THEN
            CALL PROPS(P, D, T, TAGB, 0, 0, 0)
            GOTO 600
          ENDIF
        ELSEIF (P.LT.PC(NDX) .AND. .NOT.IDGPRP .AND. P.NE.0) THEN
          CALL SATP(P, 0, DSL, DSV, TSL, TSV)
          IF (H.GE.HLQ .AND. H.LE.HVQ) THEN
            Q = (H - HLQ)/(HVQ - HLQ)
            CALL PROPS(P, DSL, TSL, TAGL, 0, 0, 1)
            IF (TSL.EQ.TSV) CALL PROPS(P, D, TSV, TAGB, 0, 1, 1)
            CALL PROPS(P, DSV, TSV, TAGV, 0, 0, 1)
            GOTO 600
          ENDIF
        ENDIF
        WRITE (*,*) ' *** ENTHALPY OUT OF BOUNDS ***'
        CALL PAUSE2

C--Calculate Properties for P,S Inputs----------------------------------
      ELSEIF (TYP.EQ.'4   '.OR.TYP.EQ.'PS  '.OR.TYP.EQ.'ps  ') THEN
        CALL INPUT1(P, 1, ERRORX)
        IF (ERRORX) GOTO 600
        IF (PRNTFLG) WRITE (*,1030) ALPHS
        READ (*,*,ERR=600) S
        S = S*SFACT
        ERRMSG = .FALSE.
        CALL DTOFPS(P, S, D, T)
        ERRMSG = .TRUE.
        IF (D.NE.0) THEN
          CALL CKLMTS(P, D, T)
          IF (D.NE.0) THEN
            CALL PROPS(P, D, T, TAGB, 0, 0, 0)
            GOTO 600
          ENDIF
        ELSEIF (P.LT.PC(NDX) .AND. .NOT.IDGPRP .AND. P.NE.0) THEN
          CALL SATP(P, 0, DSL, DSV, TSL, TSV)
          IF (S.GE.SLQ .AND. S.LE.SVQ) THEN
            Q = (S - SLQ)/(SVQ - SLQ)
            CALL PROPS(P, DSL, TSL, TAGL, 0, 0, 1)
            IF (TSL.EQ.TSV) CALL PROPS(P, D, TSV, TAGB, 0, 1, 1)
            CALL PROPS(P, DSV, TSV, TAGV, 0, 0, 1)
            GOTO 600
          ENDIF
        ENDIF
        WRITE (*,*) ' *** ENTROPY OUT OF BOUNDS ***'
        CALL PAUSE2

C--Calculate Properties for D,T Inputs----------------------------------
      ELSEIF (TYP.EQ.'5   '.OR.TYP.EQ.'TD  '.OR.TYP.EQ.'td  ') THEN
        CALL INPUT1(T, 2, ERRORX)
        IF (ERRORX) GOTO 600
        CALL INPUT1(D, 3, ERRORX)
        IF (ERRORX) GOTO 600
        IF (T.LT.TC(NDX) .AND. .NOT.IDGPRP) THEN
          CALL SATT(T, 0, DSL, DSV, PSL, PSV)
          IF (D.LE.DSL .AND. D.GE.DSV) THEN
            Q = (1.D0/D - 1.D0/DSL)/(1.D0/DSV - 1.D0/DSL)
            CALL PROPS(PSL, DSL, T, TAGL, 0, 0, 1)
            IF (PSL.EQ.PSV) CALL PROPS(PSV, D, T, TAGB, 0, 1, 1)
            CALL PROPS(PSV, DSV, T, TAGV, 0, 0, 1)
            GOTO 600
          ENDIF
        ENDIF
        P = 0
        CALL CKLMTS(P, D, T)
        IF (D.NE.0) THEN
          CALL PROPS(0.D0, D, T, TAGB, 0, 0, 0)
        ELSE
          WRITE (*,*) ' *** DENSITY OUT OF BOUNDS ***'
          CALL PAUSE2
        ENDIF

C--Calculate Properties for T,S Inputs----------------------------------
      ELSEIF (TYP.EQ.'6   '.OR.TYP.EQ.'TS  '.OR.TYP.EQ.'ts  ') THEN
        CALL INPUT1(T, 2, ERRORX)
        IF (ERRORX) GOTO 600
        IF (PRNTFLG) WRITE (*,1030) ALPHS
        READ (*,*,ERR=600) S
        S = S*SFACT
        ERRMSG = .FALSE.
        D = DOFST(S, T)
        ERRMSG = .TRUE.
        P = 0
        IF (D.NE.0) THEN
          CALL CKLMTS(P, D, T)
          IF (D.NE.0) THEN
            CALL PROPS(0.D0, D, T, TAGB, 0, 0, 0)
            GOTO 600
          ENDIF
        ELSEIF (T.LT.TC(NDX) .AND. .NOT.IDGPRP .AND. T.NE.0) THEN
          CALL SATT(T, 0, DSL, DSV, PSL, PSV)
          IF (S.GE.SLQ .AND. S.LE.SVQ) THEN
            Q = (S - SLQ)/(SVQ - SLQ)
            CALL PROPS(PSL, DSL, T, TAGL, 0, 0, 1)
            IF (PSL.EQ.PSV) CALL PROPS(PSV, D, T, TAGB, 0, 1, 1)
            CALL PROPS(PSV, DSV, T, TAGV, 0, 0, 1)
          ENDIF
          GOTO 600
        ENDIF
        WRITE (*,*) ' *** ENTROPY OUT OF BOUNDS ***'
        CALL PAUSE2

C--Calculate Properties for D,H Inputs----------------------------------
      ELSEIF (TYP.EQ.'7   '.OR.TYP.EQ.'DH  '.OR.TYP.EQ.'dh  ') THEN
        CALL INPUT1(D, 3, ERRORX)
        IF (ERRORX) GOTO 600
        IF (PRNTFLG) WRITE (*,1020) ALPHH
        READ (*,*,ERR=600) H
        H = H*HFACT
        ERRMSG = .FALSE.
        T = TOFDH(D, H)
        ERRMSG = .TRUE.
        P = 0
        CALL CKLMTS(P, D, T)
        IF (T.NE.0) THEN
          CALL PROPS(0.D0, D, T, TAGB, 0, 0, 0)
        ELSE
          WRITE (*,*) ' *** ENTHALPY OUT OF BOUNDS ***'
          CALL PAUSE2
        ENDIF

C--Calculate Properties for D,S Inputs----------------------------------
      ELSEIF (TYP.EQ.'8   '.OR.TYP.EQ.'DS  '.OR.TYP.EQ.'ds  ') THEN
        CALL INPUT1(D, 3, ERRORX)
        IF (ERRORX) GOTO 600
        IF (PRNTFLG) WRITE (*,1030) ALPHS
        READ (*,*,ERR=600) S
        S = S*SFACT
        ERRMSG = .FALSE.
        T = TOFDS(D, S)
        ERRMSG = .TRUE.
        P = 0
        CALL CKLMTS(P, D, T)
        IF (T.NE.0) THEN
          CALL PROPS(0.D0, D, T, TAGB, 0, 0, 0)
        ELSE
          WRITE (*,*) ' *** ENTROPY OUT OF BOUNDS ***'
          CALL PAUSE2
        ENDIF

C--Calculate Saturation Properties using Temperature as an Input--------
      ELSEIF (TYP.EQ.'9   '.OR.TYP.EQ.'TSAT'.OR.TYP.EQ.'tsat') THEN
        IF (IDGPRP) GOTO 600
        IF (PRNTFLG) WRITE (*,1040) ALPHT
        READ (*,*,ERR=600) T
        T = (T+CFACT)*TFACT
        IF (T.LT.TLOW(NDX) .OR. T.GT.TC(NDX) .OR. T.GT.THIGH(NDX)
     &      .OR. (DHIGH(NDX).LT.DC(NDX) .AND. T.GT.TDH1(NDX))) THEN
          WRITE (*,*) ' *** TEMPERATURE OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSE
          CALL SATT(T, 0, DSL, DSV, PSL, PSV)
          CALL PROPS(PSL, DSL, T, TAGL, 0, 0, 1)
          CALL PROPS(PSV, DSV, T, TAGV, 0, 0, 1)
        ENDIF

C--Calculate Saturation Properties using Pressure as an Input-----------
      ELSEIF (TYP.EQ.'10  '.OR.TYP.EQ.'PSAT'.OR.TYP.EQ.'psat') THEN
        IF (IDGPRP) GOTO 600
        IF (PRNTFLG) WRITE (*,1050) ALPHP
        READ (*,*,ERR=600) P
        P = (P+GFACT)*PFACT
        IF (P.LT.PSATL(NDX) .OR. P.GT.PC(NDX) .OR. P.GT.PHIGH(NDX)
     &      .OR. (DHIGH(NDX).LT.DC(NDX) .AND. P.GT.PDH1(NDX))) THEN
          WRITE (*,*) ' *** PRESSURE OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSE
          CALL SATP(P, 0, DSL, DSV, TSL, TSV)
          CALL PROPS(P, DSL, TSL, TAGL, 0, 0, 1)
          CALL PROPS(P, DSV, TSV, TAGV, 0, 0, 1)
        ENDIF

C--Calculate Saturation Properties using Temperature as an Input--------
      ELSEIF (TYP.EQ.'11  '.OR.TYP.EQ.'TX  '.OR.TYP.EQ.'tx  ') THEN
        IF (IDGPRP) GOTO 600
        IF (PRNTFLG) WRITE (*,1040) ALPHT
        READ (*,*,ERR=600) T
        IF (PRNTFLG) WRITE (*,1060)
        READ (*,*,ERR=600) Q
        T = (T+CFACT)*TFACT
        IF (T.LT.TLOW(NDX) .OR. T.GT.TC(NDX) .OR. T.GT.THIGH(NDX)) THEN
          WRITE (*,*) ' *** TEMPERATURE OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSEIF (Q.LT.0 .OR. Q.GT.1) THEN
          WRITE (*,*) ' *** QUALITY OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSE
          CALL SATT(T, 0, DSL, DSV, PSL, PSV)
          CALL PROPS(PSL, DSL, T, TAGL, 0, 0, 1)
          IF (PSL.EQ.PSV) CALL PROPS(PSV, D, T, TAGB, 0, 1, 1)
          CALL PROPS(PSV, DSV, T, TAGV, 0, 0, 1)
        ENDIF

C--Calculate Saturation Properties using Pressure as an Input-----------
      ELSEIF (TYP.EQ.'12  '.OR.TYP.EQ.'PX  '.OR.TYP.EQ.'px  ') THEN
        IF (IDGPRP) GOTO 600
        IF (PRNTFLG) WRITE (*,1050) ALPHP
        READ (*,*,ERR=600) P
        IF (PRNTFLG) WRITE (*,1060)
        READ (*,*,ERR=600) Q
        P = (P+GFACT)*PFACT
        IF (P.LT.PSATL(NDX) .OR. P.GT.PC(NDX) .OR. P.GT.PHIGH(NDX)) THEN
          WRITE (*,*) ' *** PRESSURE OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSEIF (Q.LT.0 .OR. Q.GT.1) THEN
          WRITE (*,*) ' *** QUALITY OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSE
          CALL SATP(P, 0, DSL, DSV, TSL, TSV)
          CALL PROPS(P, DSL, TSL, TAGL, 0, 0, 1)
          IF (TSL.EQ.TSV) CALL PROPS(P, DSL, TSL, TAGB, 0, 1, 1)
          CALL PROPS(P, DSV, TSV, TAGV, 0, 0, 1)
        ENDIF

C--Calculate Saturation Properties using Density as an Input--------
      ELSEIF (TYP.EQ.'13  '.OR.TYP.EQ.'DSAT'.OR.TYP.EQ.'dsat') THEN
        IF (IDGPRP) GOTO 600
        IF (PRNTFLG) WRITE (*,1070) ALPHD
        READ (*,*,ERR=600) D
        D = D*DFACT
        IF(D.LT.DSATV(NDX) .OR. D.GT.DSATL(NDX).OR. D.GT.DHIGH(NDX))THEN
          WRITE (*,*) ' *** DENSITY OUT OF BOUNDS ***'
          CALL PAUSE2
        ELSE
          CALL SATD(D, 0, DSV, PSAT, TSAT)
          DSL = D
          IF (D.LT.DC(NDX)) THEN
            DSL = DSV
            DSV = D
          ENDIF
          IF (DSL.NE.0) CALL PROPS(PSAT, DSL, TSAT, TAGL, 0, 0, 1)
          IF (DSV.NE.0) CALL PROPS(PSAT, DSV, TSAT, TAGV, 0, 0, 1)
        ENDIF

C--View Current Program and Fluid Status--------------------------------
      ELSEIF (TYP(1:1).EQ.'S'.OR.TYP(1:1).EQ.'s') THEN
        CALL STATUS

C--Return to the Main Menu----------------------------------------------
      ELSEIF (TYP.EQ.'0   '.OR.TYP(1:1).EQ.'Q'.OR.TYP(1:1).EQ.'q') THEN
        RETURN
      ENDIF
      GOTO 600

C-----------------------------------------------------------------------
 1000 FORMAT (/,' SINGLE POINT MENU (Select an input option):',/
     &'   (1)  P, T      (5)  T, D      (9)  TSAT     (13)  DSAT',/
     &'   (2)  P, D      (6)  T, S     (10)  PSAT      (S)  Status',/
     &'   (3)  P, H      (7)  D, H     (11)  T, x      (C)  Clear Pad',/
     &'   (4)  P, S      (8)  D, S     (12)  P, x      (0)  Quit',/
     &'   ====>  ')
 1010 FORMAT (/,' IDEAL GAS POINT MENU (Select an input option):',/
     &'   (1)  P, T      (5)  T, D',/
     &'   (2)  P, D      (6)  T, S      (S)  Status',/
     &'   (3)  P, H      (7)  D, H      (C)  Clear Pad',/
     &'   (4)  P, S      (8)  D, S      (0)  Quit',/
     &'   ====>  ')
 1020   FORMAT ('+ Input Enthalpy, ',A10,'    ====>  ')
 1030   FORMAT ('+ Input Entropy, ',A10,'     ====>  ')
 1040   FORMAT ('+ Input Saturation Temperature, ',A10,'    ====>  ')
 1050   FORMAT ('+ Input Saturation Pressure, ',A10,'    ====>  ')
 1070   FORMAT ('+ Input Saturation Density, ',A10,'    ====>  ')
 1060   FORMAT ('+ Input Quality    ====>  ')
      END
